// GLapplic.h
#if !defined(__GLAPPLIC_H)
#define __GLAPPLIC_H
#include <gl/gl.h>
#include <gl/glu.h>
#include <gl/glaux.h>

class CAppWindow
{
public:
	CAppWindow(PSTR szName="AppWindow");
	virtual ~CAppWindow();
	HWND GetHandle() { return hWnd; }
	int Run();
	long MsgProc(UINT lMessage, UINT sParam, LONG lParam);
	int SetPalette(BOOL bForceBkgnd);
	void Destroy();
	void Invalidate(BOOL Flag = TRUE);

protected:
	HWND hWnd;
	PSTR Name;
	HGLRC hrc;
	
	HPALETTE hpal;
	int Width, Height;

	void Create();
	void OnCreate();
	
	// User-defined operations
	virtual void OnSize(int cx, int cy);
	virtual void PrepareScene() { }
	virtual void DrawScene() { }
	virtual void SetupWindow() { }
	virtual void CleanupWindow() { }
	virtual void WmCommand(UINT wParam, LONG lParam) { }
	virtual void WmDrawItem(UINT wParam, LONG lParam) { }
	virtual void WmKeyDown(UINT wParam, LONG lParam) { }
	virtual void WmChar(UINT wParam, LONG lParam) { }
	virtual void WmLButtonDown(int keys, POINT pt) { }
	virtual void WmRButtonDown(int keys, POINT pt) { }
	virtual void WmMouseMove(int keys, POINT pt) { }
	virtual void WmLButtonUp(int keys, POINT pt) {  }
	virtual void WmRButtonUp(int keys, POINT pt) {  }
	virtual void WmSetFocus() { }
	virtual void WmKillFocus() { }
	virtual void WmSize(int width, int height) { }
	virtual void WmTimer() { }
	virtual void WmVScroll(UINT wParam, LONG lParam) { }
};

HINSTANCE GetInstance();
PSTR GetCmdLine();

inline void MoveTo(HDC hdc, int x, int y)
{
	MoveToEx(hdc,x,y,0);
}

#endif
