/** cube1.cpp
*
*   Demonstrate OpenGL functions
*
**/
#define WIN32_LEAN_AND_MEAN
#include <stdlib.h>
#include <math.h>
#include <windows.h>
#include "GLapplic.h"

#define OBJ_CUBE  1

class MyApp: public CAppWindow
{
	public:
		MyApp(char *name);
		void PrepareScene();
		void DrawScene();
};

MyApp::MyApp(char *name): CAppWindow(name)
{
	Width  = 480 ;
	Height = 360 ;
}

void MyApp::PrepareScene()
{
	glNewList(OBJ_CUBE, GL_COMPILE) ; 
	//
	// Draw the six faces of the cube.
	//
	glBegin (GL_POLYGON);
	glVertex3f (1.0f, 1.0f, 1.0f);
	glVertex3f (-1.0f, 1.0f, 1.0f);            
	glVertex3f (-1.0f, -1.0f, 1.0f);           
	glVertex3f (1.0f, -1.0f, 1.0f);            
	glEnd ();

	glBegin (GL_POLYGON);
	glVertex3f (1.0f, 1.0f, -1.0f);
	glVertex3f (1.0f, -1.0f, -1.0f);           
	glVertex3f (-1.0f, -1.0f, -1.0f);          
	glVertex3f (-1.0f, 1.0f, -1.0f);           
	glEnd ();

	glBegin (GL_POLYGON);
	glVertex3f (-1.0f, 1.0f, 1.0f);
	glVertex3f (-1.0f, 1.0f, -1.0f);           
	glVertex3f (-1.0f, -1.0f, -1.0f);          
	glVertex3f (-1.0f, -1.0f, 1.0f);           
	glEnd ();

	glBegin (GL_POLYGON);
	glVertex3f (1.0f, 1.0f, 1.0f);
	glVertex3f (1.0f, -1.0f, 1.0f);            
	glVertex3f (1.0f, -1.0f, -1.0f);           
	glVertex3f (1.0f, 1.0f, -1.0f);            
	glEnd ();

	glBegin (GL_POLYGON);
	glVertex3f (-1.0f, 1.0f, -1.0f);
	glVertex3f (-1.0f, 1.0f, 1.0f);            
	glVertex3f (1.0f, 1.0f, 1.0f);             
	glVertex3f (1.0f, 1.0f, -1.0f);            
	glEnd ();

	glBegin (GL_POLYGON);
	glVertex3f (-1.0f, -1.0f, -1.0f);
	glVertex3f (1.0f, -1.0f, -1.0f);           
	glVertex3f (1.0f, -1.0f, 1.0f);            
	glVertex3f (-1.0f, -1.0f, 1.0f);           
	glEnd ();
	glEndList() ;			   
}

void MyApp::DrawScene()
{
	//
	// Enable depth testing and clear the color and depth buffers.
	//
	glEnable (GL_DEPTH_TEST);
	glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	//
	// Define the modelview transformation.
	//
	glMatrixMode (GL_MODELVIEW);
	glLoadIdentity ();
	glTranslatef (0.0f, 0.0f, -8.0f);
	glRotatef (30.0f, 1.0f, 0.0f, 0.0f);
	glRotatef (70.0f, 0.0f, 1.0f, 0.0f);

	//
	// Set the drawing color to blue.
	//
	glColor3f (0.0f, 0.0f, 1.0f);

	// Draw the cube
	glCallList(OBJ_CUBE) ;

	//
	// Flush the drawing pipeline.
	//
	glFlush ();
}

int Main()
{
	return MyApp("cube1").Run();
}
